
package de.ivu.elect.presentation.staat.menu;

import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.staat.boundary.StaatenGruppeTypFinder;
import de.ivu.elect.business.staat.entity.StaatenGruppeMeta;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelector;
import de.ivu.elect.business.wahl.boundary.WahlterminSessionSelect;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public abstract class AbstractStaatenGruppeMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private StaatenGruppeMeta staatenGruppeMeta;

  @Inject
  private WahlSessionSelector wahlSelect;

  @Inject
  private WahlterminSessionSelect wahlterminSelect;

  @Inject
  private StaatenGruppeTypFinder staatenGruppeTypFinder;

  public AbstractStaatenGruppeMenuItemEntry() {
    super();
  }

  protected StaatenGruppeMeta getMeta() {
    return staatenGruppeMeta;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(getUseCasePermission()) && staatenGruppeTypFinder.isStaatenGruppeTypExceptUnbekanntSupported();
  }

  protected abstract UseCasePermission getUseCasePermission();

  @Override
  public boolean isDisabledInternal() {
    return !isWahlSelected() && !isWahlterminSelected();
  }

  private boolean isWahlSelected() {
    return wahlSelect.isSelected();
  }

  private boolean isWahlterminSelected() {
    return wahlterminSelect.isSelected();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }
}
